# coding: utf-8

"""
    Magneto API

    Magneto API is the RESTful API for the Rely.io platform.

    The version of the OpenAPI document: v0.0.1
    Contact: contact@rely.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from magneto_api_client.models.flow_action import FlowAction
from magneto_api_client.models.flow_output import FlowOutput
from magneto_api_client.models.flow_trigger import FlowTrigger
from magneto_api_client.models.flow_type import FlowType
from magneto_api_client.models.tag import Tag
from typing import Optional, Set
from typing_extensions import Self

class FlowRead(BaseModel):
    """
    Flow Read Model.
    """ # noqa: E501
    id: Annotated[str, Field(strict=True)]
    title: Annotated[str, Field(min_length=1, strict=True)]
    description: Optional[StrictStr] = None
    icon: Optional[StrictStr] = None
    is_active: Optional[StrictBool] = Field(default=True, alias="isActive")
    needs_approval: Optional[StrictBool] = Field(default=False, alias="needsApproval")
    order: Optional[StrictInt] = 0
    type: FlowType
    arguments: Optional[Dict[str, Any]] = None
    secrets: Optional[Dict[str, Any]] = None
    triggers: Optional[List[FlowTrigger]] = None
    actions: Optional[List[FlowAction]] = None
    outputs: Optional[Dict[str, FlowOutput]] = None
    tags: Optional[List[Tag]] = None
    created_at: datetime = Field(alias="createdAt")
    created_by: Optional[StrictInt] = Field(default=None, alias="createdBy")
    updated_at: datetime = Field(alias="updatedAt")
    updated_by: Optional[StrictInt] = Field(default=None, alias="updatedBy")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["id", "title", "description", "icon", "isActive", "needsApproval", "order", "type", "arguments", "secrets", "triggers", "actions", "outputs", "tags", "createdAt", "createdBy", "updatedAt", "updatedBy"]

    @field_validator('id')
    def id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^([a-z0-9_.-]+)$", value):
            raise ValueError(r"must validate the regular expression /^([a-z0-9_.-]+)$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FlowRead from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in triggers (list)
        _items = []
        if self.triggers:
            for _item_triggers in self.triggers:
                if _item_triggers:
                    _items.append(_item_triggers.to_dict())
            _dict['triggers'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in actions (list)
        _items = []
        if self.actions:
            for _item_actions in self.actions:
                if _item_actions:
                    _items.append(_item_actions.to_dict())
            _dict['actions'] = _items
        # override the default output from pydantic by calling `to_dict()` of each value in outputs (dict)
        _field_dict = {}
        if self.outputs:
            for _key_outputs in self.outputs:
                if self.outputs[_key_outputs]:
                    _field_dict[_key_outputs] = self.outputs[_key_outputs].to_dict()
            _dict['outputs'] = _field_dict
        # override the default output from pydantic by calling `to_dict()` of each item in tags (list)
        _items = []
        if self.tags:
            for _item_tags in self.tags:
                if _item_tags:
                    _items.append(_item_tags.to_dict())
            _dict['tags'] = _items
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FlowRead from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "title": obj.get("title"),
            "description": obj.get("description"),
            "icon": obj.get("icon"),
            "isActive": obj.get("isActive") if obj.get("isActive") is not None else True,
            "needsApproval": obj.get("needsApproval") if obj.get("needsApproval") is not None else False,
            "order": obj.get("order") if obj.get("order") is not None else 0,
            "type": obj.get("type"),
            "arguments": obj.get("arguments"),
            "secrets": obj.get("secrets"),
            "triggers": [FlowTrigger.from_dict(_item) for _item in obj["triggers"]] if obj.get("triggers") is not None else None,
            "actions": [FlowAction.from_dict(_item) for _item in obj["actions"]] if obj.get("actions") is not None else None,
            "outputs": dict(
                (_k, FlowOutput.from_dict(_v))
                for _k, _v in obj["outputs"].items()
            )
            if obj.get("outputs") is not None
            else None,
            "tags": [Tag.from_dict(_item) for _item in obj["tags"]] if obj.get("tags") is not None else None,
            "createdAt": obj.get("createdAt"),
            "createdBy": obj.get("createdBy"),
            "updatedAt": obj.get("updatedAt"),
            "updatedBy": obj.get("updatedBy")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


